<template>
  <div class="all">
    <!--  -->
    <div class="cluster-guanli" v-if="showCurCluster && isHasColony">
      <!-- <cloud-node :nodes="innerNodes"></cloud-node> -->
      <net-node :innerNodes="innerNodes"></net-node>

      <div class="cls-bar">视频分析集群管理</div>

      <div class="cls-bar">
        <div class="title">集群名称</div>
        <div class="input-area">
          <div class="text" v-show="!isFillingName">
            {{ ruleForm.clustername }}
          </div>
          <el-input
            v-show="isFillingName"
            size="mini"
            v-model="selfForm.clustername"
            placeholder="请输入内容"
          ></el-input>
          <span
            class="icon iconfont"
            @click="startInput(1)"
            v-show="!isFillingName"
            >&#xe60c;</span
          >
          <span
            class="icon iconfont"
            style="font-size: 18px"
            @click="clearInput(1)"
            v-show="isFillingName"
            >&#xe785;</span
          >
          <span
            class="icon iconfont"
            style="font-size: 20px; color: var(--colorCard)"
            @click="updateCluster(1)"
            v-show="isFillingName"
            >&#xe62a;</span
          >
        </div>
      </div>
      <div class="cls-bar">
        <div class="title">集群ID</div>
        <div class="input-area">
          <div class="text">{{ clusterid }}</div>
        </div>
      </div>
      <div class="cls-bar">
        <div class="title">集群密码</div>
        <div class="input-area">
          <div class="text">{{ ruleForm.clusterpwd }}</div>
        </div>
      </div>
      <div class="cls-bar">
        <div class="title">集群IP</div>
        <div class="input-area">
          <div class="text" v-show="!isFillingIp">{{ ruleForm.virtualIp }}</div>

          <ip-input
            v-if="isFillingIp"
            :ip="selfForm.virtualIp"
            :on-blur="onIpBlur"
            class="ip-input-comp"
          ></ip-input>
          <span
            class="icon iconfont"
            v-show="!isFillingIp"
            @click="startInput(2)"
            >&#xe60c;</span
          >
          <span
            class="icon iconfont"
            style="font-size: 18px"
            @click="clearInput(2)"
            v-show="isFillingIp"
            >&#xe785;</span
          >
          <span
            class="icon iconfont"
            @click="updateCluster(2)"
            style="font-size: 20px; color: var(--colorCard)"
            v-show="isFillingIp"
            >&#xe62a;</span
          >
        </div>
      </div>
      <div class="btns">
        <div class="ok" @click="updateCluster">保存</div>
        <div class="exit" @click="exitCluster">退出集群</div>
      </div>
    </div>
    <!-- !showCurCluster || !isHasColony -->
    <div class="cluster-content" v-if="!showCurCluster || !isHasColony">
      <div class="cluster-center" ref="left" v-if="!showCurCluster || !isHasColony">
        <div
          class="menu-item"
          :class="activePage == i ? 'menu-item-active' : ''"
          v-for="(item, i) in tabList"
          :key="i"
          @click="openRight(i)"
        >
          <span class="icon iconfont" v-if="activePage == 0">&#xe73c;</span>
          <span class="icon iconfont" v-if="activePage == 1">&#xe721;</span>
          {{ item }}
        </div>
      </div>
      <div class="cluster-right" v-if="!showCurCluster || !isHasColony">
        <div class="create-new" v-if="activePage == 0">
          <el-form :model="ruleForm" :rules="rules" ref="ruleForm">
            <el-form-item prop="clustername">
              <div class="p-title">集群名称</div>
              <el-input
                v-model="ruleForm.clustername"
                placeholder="手动输入, 如“集群A”"
                size="small"
              ></el-input>
            </el-form-item>
            <el-form-item>
              <div class="p-title">集群ID</div>
              <el-input
                v-model="clusterid"
                placeholder="不允许输入,保存后回显"
                disabled
                size="small"
              ></el-input>
            </el-form-item>
            <el-form-item prop="clusterpwd">
              <div class="p-title">集群密码</div>
              <el-input
                v-model="ruleForm.clusterpwd"
                placeholder="请输入6位密码,或点击生成"
                size="small"
              >
                <el-button type="text" slot="suffix" @click="getPSW"
                  >生成密码</el-button
                >
              </el-input>
            </el-form-item>
            <el-form-item prop="virtualIp">
              <div class="p-title">集群IP</div>
              <ip-input
                :ip="ruleForm.virtualIp"
                :on-blur="onIpBlur"
                class="ip-input-comp"
              ></ip-input>
            </el-form-item>
          </el-form>
          <div class="btns">
            <div class="ok" @click="saveCluster('ruleForm')">保存</div>
          </div>
        </div>

        <div class="join-exist" v-if="activePage == 1">
          <el-form
            :model="joinForm"
            :rules="joinExistRules"
            ref="joinForm"
            class="join-form"
         
            v-loading="joinLoading"
          >
            <el-form-item  prop="clusterid">
              <div class="p-title">集群ID</div>
              <el-input v-model="joinForm.clusterid" size="small"></el-input>
            </el-form-item>

            <el-form-item  prop="clusterip">
              <div class="p-title">IP地址</div>
              <el-input
                v-model="joinForm.clusterip"
                placeholder="请输入集群内任意IP地址"
                size="small"
                autocomplete="new-password"
              ></el-input>
            </el-form-item>
            <el-form-item  prop="clusterpwd">
              <div class="p-title">集群密码</div>
              <el-input
                v-model="joinForm.clusterpwd"
                placeholder="请输入集群密码"
                show-password
                autocomplete="new-password"
                size="small"
              >
                <el-button
                  type="text"
                  slot="suffix"
                  @click="searchColony"
                  v-show="!searchDis"
                  >搜索集群</el-button
                >
                <el-button
                  type="text"
                  slot="suffix"
                  v-show="searchDis"
                  @click="stopSearch"
                >
                  <i class="el-icon-loading"></i>停止搜索
                </el-button>
              </el-input>
            </el-form-item>
          </el-form>
           <div class="btns">
        <div class="ok" @click="join('joinForm')">加入集群</div>
      </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {
  createSerfCluster,
  randomPwd,
  leave,
  search,
  getSearchNodes,
  stopSearching,
  findCluster,
  updateClusterName,
  joinCluster,
} from "@/api/clusterManage";
// import cloudNode from "../components/CloudNode";
import NetNode from '../components/NetNode'
import ipInput from "../components/IPInput";
import { isIPv4 } from "@/scripts/validate";

export default {
  data() {
    const checkPwd = (rule, value, callback) => {
      if (!value) {
        return callback(new Error("密码不能为空"));
      }
      setTimeout(() => {
        if (value.length != 6) {
          callback(new Error("密码应为6位!"));
        } else {
          callback();
        }
      }, 1000);
    };
    const checkID = (rule, value, callback) => {
      if (!value) {
        return callback(new Error("密码不能为空"));
      }
    };
    return {
      innerNodes: [],
      intervalTimer: null,
      isFillingName: false,
      isFillingIp: false,
      inputName: "",
      activePage: 0,
      inputIp: "",
      serverIp: "",
      members: [],
      virtualIp: "192.168.1.188",
      searchDis: false,
      ruleForm: {
        clustername: "",
        clusterpwd: "",
        virtualIp: "",
      },
      selfForm: {
        virtualIp: "",
        clustername: "",
      },
      joinForm: {
        clusterid: "",
        clusterip: "",
        clusterpwd: "",
      },
      isSearch: false,
      showCurCluster: true,
      loading: false,
      joinLoading: false,
      isHasColony: false,
      clusterid: "",
      searchNum: "",
      scheduleId: "",
      isCreate: true,
      tabList: ["创建集群", "加入已有集群"],
      rules: {
        clustername: [
          { required: true, message: "请输入集群名称", trigger: "blur" },
        ],
        clusterpwd: [{ validator: checkPwd, trigger: "blur" }],
        virtualIp: [{ required: true, validator: isIPv4, trigger: "change" }],
      },
      joinExistRules: {
        clusterid: [{ validator: checkID, trigger: "blur" }],
        clusterip: [{ validator: isIPv4, trigger: "blur" }],
        clusterpwd: [{ validator: checkPwd, trigger: "blur" }],
      },
    };
  },
  components: {
    // cloudNode,
    NetNode,
    ipInput
  },
  mounted() {
    this.findCluster();
    this.intervalTimer = setInterval(() => {
      this.findCluster();
    }, 30000);
  },
  beforeDestroy() {
    clearInterval(this.intervalTimer);
  },
  methods: {
    async createCluster(json) {
      let res = await createSerfCluster(json);
      this.$notify({
        title: res.success ? "成功" : "失败",
        message: res.msg,
        type: res.success ? "success" : "error",
      });
    },
    //搜索集群
    async getSearchNodes() {
      let res = await getSearchNodes();
      if (res && res.success) {
        let list = res.data.map((i) => {
          let obj = {};
          obj.cluster_id = i.clusterID ? i.clusterID : "";
          obj.create_time = i.create_time ? i.create_time : "";
          obj.id = i.nodeID ? i.nodeID : "";
          obj.node_id = i.nodeID ? i.nodeID : "";
          obj.Address = i.nodeAddress ? i.nodeAddress : "";
          obj.nodeName = i.nodeAddress ? i.nodeAddress : "";
          obj.role = i.role ? i.role : "pc";
          return obj;
        });
        list.map((i) => {
          let found = this.members.find((element) => {
            return element.node_id === i.node_id;
          });
          if (found === undefined) {
            this.members.push(i);
          }
        });
      }
    },
    async joinCluster(json) {
      let res = await joinCluster(json);
      if (res.success) {
        this.members = [];
      }
      this.$notify({
        title: res.success ? "成功" : "失败",
        message: res.msg,
        type: res.success ? "success" : "error",
      });
    },
    join(formName) {
      debugger
      let _this = this;
      this.$refs[formName].validate((valid) => {
      debugger
        if (valid) {
      debugger
          _this.joinLoading = true;
          let nodeIps = _this.members.map((i) => {
            return i.Address;
          });
          let data = {
            clusterId: _this.joinForm.clusterid,
            password: _this.joinForm.clusterpwd,
            nodeIps: [_this.joinForm.clusterip],
          };
          _this
            .joinCluster(data)
            .then(() => {
              _this.joinLoading = false;
              _this.findCluster();
            })
            .catch((e) => {
              _this.joinLoading = false;
            });
        } else {
          return false;
        }
      });
    },
    setSchedule() {
      this.scheduleId = window.setInterval(() => {
        this.getSearchNodes();
      }, 1000);
    },
    async searchColony() {
      this.isSearch = true;
      this.$refs["joinForm"].clearValidate();
      this.$refs["joinForm"].validateField("clusterpwd");
      if (this.joinForm.clusterpwd.trim().length === 6) {
        this.members = [];
        const data = {
          password: this.joinForm.clusterpwd,
        };
        this.search(data)
          .then(() => {
            this.setSchedule();
          })
          .catch(() => {
            this.searchDis = false;
            this.loading = false;
            this.isSearch = false;
          });
      } else {
        this.searchDis = false;
        this.loading = false;
        this.isSearch = false;
        return false;
      }
    },
    async search(data) {
      let res = await search(data);
      if (res && res.success) {
        this.searchNum = res.data;
      }
      this.searchDis = true;
      this.loading = true;
      window.setTimeout(() => {
        this.stopSearch();
      }, 10 * 1000);
    },
    openRight(i) {
      this.activePage = i;
    },
    async stopSearch() {
      if (!this.loading) {
        return true;
      }
      stopSearching({
        searchNum: this.searchNum,
      })
        .then((res) => {
          this.loading = false;
          this.searchDis = false;
          window.clearInterval(this.scheduleId);
        })
        .catch((err) => {
          this.$notify({
            type: "error",
            duration: 1000,
            message: "停止搜索报错！",
          });
        });
    },
    saveCluster(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          let data = {
            clusterId: this.clusterid,
            clusterName: this.ruleForm.clustername,
            password: this.ruleForm.clusterpwd,
            virtualIp: this.ruleForm.virtualIp,
          };
          this.createCluster(data).then(() => {
            this.findCluster();
          });
        } else {
          return false;
        }
      });
    },
    getPSW() {
      var chars =
        "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
      var uuid = [];

      for (let i = 0; i < 6; i++) {
        uuid[i] = chars[0 | (Math.random() * 50)];
      }

      this.ruleForm.clusterpwd = uuid.join("");
    },
    exitCluster() {
      const h = this.$createElement;
      this.$msgbox({
        title: "",
        message: h(
          "div",
          {
            style:
              "display: flex;  flex-direction: column; justify-content: center; align-items: center;",
          },
          [
            h("span", { class: "icon iconfont warn-icon" }, "\ue71c"),
            h("span", { class: "warn-title" }, "退出集群"),
            h("span", { class: "warn-dec" }, "确定退出集群吗？"),
          ]
        ),
        showCancelButton: true,
        showClose: true,
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        customClass: "del-account-message-box",
      }).then(
        async () => {
          let res = await leave();
          this.$notify({
            title: res.success ? "成功" : "失败",
            message: res.msg,
            type: res.success ? "success" : "error",
          });
          if (res && res.success) {
            clearInterval(this.intervalTimer);
            this.showCurCluster = false;
            this.ruleForm.virtualIp = "";
            this.ruleForm.clustername = "";
            this.ruleForm.clusterpwd = "";
            this.clusterid = "";
          }
        },
        (err) => {
          clearInterval(this.intervalTimer);
          this.showCurCluster = false;
          this.ruleForm.virtualIp = "";
          this.ruleForm.clustername = "";
          this.ruleForm.clusterpwd = "";
          this.clusterid = "";
        }
      );
    },
    clearInput(typ) {
      if (typ == 1) {
        this.selfForm.clustername = "";
        this.isFillingName = false;
      } else {
        this.selfForm.virtualIp = "";
        this.isFillingIp = false;
      }
    },
    async randomPwd() {
      let res = await randomPwd();
      if (res && res.success) {
        this.ruleForm.clusterpwd = res.data;
      }
    },
    startInput(typ) {
      if (typ == 1) {
        this.selfForm.clustername = this.ruleForm.clustername;
        this.isFillingName = true;
      } else {
        this.selfForm.virtualIp = this.ruleForm.virtualIp;
        this.isFillingIp = true;
      }
    },
    onIpBlur(ip) {
      this.ruleForm.virtualIp = ip;
    },
    async updateCluster(v) {
      if (v == 1 || v == undefined) {
        this.ruleForm.clustername = this.selfForm.clustername;
      }
      if (this.ruleForm.clustername === "") {
        this.$message({
          type: "error",
          message: "集群名称不能为空",
        });
        return;
      }
      const data = {
        clusterName: this.ruleForm.clustername,
        virtualIp: this.ruleForm.virtualIp,
      };
      let res = await updateClusterName(data);
      if (res.success) {
        this.findCluster();
      }

      this.$notify({
        title: res.success ? "成功" : "失败",
        message: res.msg,
        type: res.success ? "success" : "error",
      });
      this.isFillingIp = false;
      this.isFillingName = false;
    },
    async findCluster() {
      let res = await findCluster();
      if (res && res.success) {
        if (res.data && res.data.clusterId) {
          this.isHasColony = true;
          this.clusterid = res.data.clusterId;
          this.ruleForm.clustername = res.data.clusterName;
          this.ruleForm.clusterpwd = "******";
          this.ruleForm.virtualIp = res.data.virtualIp;
          this.isSearch = false;
          this.innerNodes = res.data.nodes.map((i) => {
            let obj = {};
            obj.device_type = i.device_type;
            obj.workType = i.device_type.substr(2, 2);
            obj.hardwareType = i.device_type.substr(4, 2);
            obj.cluster_id = i.cluster_id;
            obj.clusterName = res.data.clusterName;
            obj.create_time = i.create_time;
            obj.id = i.id;
            obj.node_id = i.node_id;
            obj.node_ip = i.node_ip;
            obj.nodeName = i.node_name;
            obj.Address = i.node_ip;
            obj.role = i.drift_state ? i.drift_state : "pc";
            return obj;
          });
        } else {
          this.isHasColony = false;
        }
      }
    },
    clearInnerNodes() {
      this.innerNodes = [];
    },
  },
};
</script>
<style lang="scss">
.all {
  width: 100%;
  background: #f2f2f7;
}
.cluster-guanli {
  margin: 0 auto;
width: 760px; 
  padding: 0 10px;
  .btns {
    margin-top: 30px !important;

    .exit {
      width: 188px;
      height: 40px;
      cursor: pointer;
      border-radius: 25px;
      background-color: #fe6d68;
      color: #fff;
      line-height: 40px;
      font-weight: bold;
      font-size: 16px;
      margin-left: 60px;
      margin-top: 0;
    }
  }
  .cloud {
    width: 100%;
    display: flex;
    height: 255px;
    border-radius: 8px;
    background: linear-gradient(
      180deg,
      #ffffff 0%,
      rgba(255, 255, 255, 0) 100%
    );
    .inner {
      background: url(/images/settings/easy-cloud.png) no-repeat;
      background-size: contain;
      margin: 0 auto;
      width: 240px;
      .rect {
        position: relative;
        margin: 0;
        height: 100%;
      }
    }
  }
  .cls-bar {
    height: 48px;
    background-color: #ffffff;
    margin-bottom: 6px;
    display: flex;
    box-sizing: border-box;
    padding: 0 30px;
    justify-content: space-between;
    align-items: center;
    border-radius: 8px;
    font-weight: bold;
    font-size: 14px;
    color: #333333;
    .title {
      font-size: 14px;
    }
    .input-area {
      display: flex;
      width: 540px;
      height: 30px;
      line-height: 30px;
      justify-content: inherit;
      box-sizing: border-box;
      background: #f2f2f7;
      border-radius: 20px;
      padding: 0 30px;
      .el-input--mini .el-input__inner {
        height: 24px;
        line-height: 24px;
        /* border: 1px solid transparent; */
        background: inherit;
        padding-left: 0;
        border: none;
        border-radius: 0px;
        font-size: 14px;
      }

      .icon {
        cursor: pointer;
        font-size: 14px;
        margin-left: 10px;
      }
    }
  }
  .exit {
    background-color: #3d68e1;
    width: 240px;
    height: 40px;
    margin: 0 auto;
    border-radius: 10px;
    color: #fff;
    line-height: 40px;
    font-size: 14px;
    margin-top: 20px;
    cursor: pointer;
  }
}
.cluster-content {
  height: 100%;
  display: flex;
  flex-direction: row;
  flex: 1;
  flex-basis: auto;
  box-sizing: border-box;
  background: #fbfaff;

  .cluster-center {
    height: 100%;
    width: 280px;
    overflow: auto;
    box-sizing: border-box;
    flex-shrink: 0;
    padding: 10px;
    padding-top: 6px;
    border-right: 4px solid #f2f2f7;
    border-left: 4px solid #f2f2f7;
    border-top: 4px solid #f2f2f7;
    .menu-item {
      background-color: #f8f8f8;
      cursor: pointer;
      height: 56px;
      margin-bottom: 10px;
      border-radius: 8px;
      line-height: 56px;
      text-align: left;
      box-sizing: border-box;
      padding: 0 20px;
      font-weight: bold;
      font-size: 16px;
    }
    .menu-item-active {
      background-color: var(--colorCard);
      color: white;
    }
    // .menu-item:hover {
    //   background-color: var(--colorCard);
    //   color: white;
    // }
  }
  .cluster-right {
    flex: 1;
    flex-basis: auto;
    overflow: auto;
    box-sizing: border-box;
    position: relative;
    border-top: 4px solid #f2f2f7;
    padding: 20px 40px;
    padding-top: 16px;
    .el-form-item.is-required:not(.is-no-asterisk)
      > .el-form-item__label:before,
    .el-form-item.is-required:not(.is-no-asterisk)
      .el-form-item__label-wrap
      > .el-form-item__label:before {
      display: none;
    }

    .el-form-item__content {
      line-height: 48px;
      display: flex;
      align-items: center;
      background: #f2f2f7;
      border-radius: 8px;
      padding: 0 15px 0 20px;
      .el-select-dropdown__item {
        color: #333333;
        height: 32px;
        font-size: 12px;
        line-height: 32px;
        text-align: center;
      }
      .el-popper {
        margin-top: 0;
        background: #fbfaff;
        box-shadow: 0px 2px 6px rgb(0 0 0 / 18%);
        border-radius: 2px;
        .el-select-dropdown__item.hover,
        .el-select-dropdown__item:hover {
          background-color: #f2f2f7;
          color: var(--colorCard);
        }
      }
    }
    .el-form-item__error {
      line-height: 0.7;
      left: 20px;
    }
    .el-form-item {
    margin-bottom: 10px;
      .el-input__inner {
        background-color: #ffffff;
        border: 2px solid transparent;
        border-radius: 20px;
        height: 32px;
        line-height: 32px;
        padding: 0 15px;
        font-size: 14px;
        font-weight: bold;
      }
      .el-input__inner:focus {
        border: 2px solid var(--colorCard);
      }
      .el-input__inner::placeholder {
        color: #c0c4cc;
        font-size: 12px;
        font-weight: normal;
      }
      .el-select {
        width: 100%;
      }
      .el-select .el-input .el-select__caret {
        color: #333333;
        font-size: 14px;
        font-weight: 600;
      }
    }
    .p-title {
      height: 48px;
      text-align: left;
      line-height: 48px;
      width: 90px;
      font-weight: 600;
    }
    .ip-input-container {
      max-width: none !important;
      height: 32px;
      line-height: normal;
      box-sizing: border-box;
      // background-color: #f2f2f7;
      text-align: left;
      border-radius: 20px;
      border: 2px solid transparent;
    }
    .ntp-bar {
      height: 40px;
      background-color: rgba(248, 248, 248, 1);
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0 10px;
      border-radius: 10px;
      margin-bottom: 10px;
      .title {
        min-width: 70px;
      }
      .input-area {
        min-width: 400px;
        height: 30px;
        background-color: rgba(240, 240, 240, 1);
        border-radius: 10px;
        line-height: 30px;
        font-size: 14px;
      }
    }
    .int-bar {
      height: 40px;
      background-color: rgba(248, 248, 248, 1);
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0 10px;
      border-radius: 10px;
      margin-bottom: 10px;
      .title {
        min-width: 70px;
      }
      .right {
        min-width: 400px;
        display: flex;
        align-items: center;
        height: 30px;
        .input-area {
          background-color: rgba(240, 240, 240, 1);
          border-radius: 10px;
          line-height: 30px;
          width: -webkit-fill-available;

          font-size: 14px;
        }
        .test {
          width: 70px;
        }
      }
    }
    .save-btn {
      background-color: #3d68e1;
      width: 240px;
      height: 40px;
      margin: 0 auto;
      border-radius: 10px;
      color: #fff;
      line-height: 40px;
      font-size: 14px;
      margin-top: 20px;
    }
  }
}
</style>
